/*
SimpleGame PDDL problem generator v1

DATE   : 6 July 2011
FILE   : SimpleGame_PDDL_ProblemGenerator.c
AUTHOR : Michail Papakonstantinou
EMAIL  : sdi0600151@di.uoa.gr

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAXFILENAME 32
#define MAXLINE 256


main(int argc, char* argv[])
{
	FILE* fp;
      	int iSize,jSize;
     	int i,j;
      	char** level;
      	char line[MAXLINE];
      	char filename[MAXFILENAME];
      	char outputFilename[MAXFILENAME];
	
	if(argc!=0)
	{
		if(argc<5)
		{
			printf("Sample execution <executable_name> -i <inputfile> -o <outputfile>\n");
			exit(0);
		}
		for(i=1;i<argc;i+=2)
		{
			if(strcmp(argv[i],"-i")==0)
				strcpy(filename,argv[i+1]);
			else if(strcmp(argv[i],"-o")==0)
				strcpy(outputFilename,argv[i+1]);
		}
	}
	else
	{
		printf("Input file name:\n");
      		scanf("%s",filename);
	}

      	fp=fopen(filename,"r");
      	fscanf(fp,"%d %d",&iSize,&jSize);
      	level=(char**)malloc(iSize*sizeof(char*));
      	for(i=0;i<iSize;i++)
      		level[i]=(char*)malloc(jSize*sizeof(char));
      	i=0;
      	j=0;
      	
	while(i!=iSize)
      	{
          	level[i][j]=fgetc(fp);
          	if(level[i][j]!='\n')
                	j++;
          	if(j==jSize)
          	{
                 	j=0;
                      	i++;
          	}
      	}
      	fclose(fp);
      
	printf("Level to generate is..\n");
	for(i=0;i<iSize;i++)
      	{
        	for(j=0;j<jSize;j++)
                	printf("|%c|",level[i][j]);
             	printf("\n");
      	}
      
	if(argc==1)
	{
      		printf("Output file name:\n");
      		scanf("%s",outputFilename);
      	}
	
	fp=fopen(outputFilename,"w");
      	sprintf(line,"(define (problem simplegame1)\n(:domain simplegame)\n(:objects up down left right\nk g\n");
      	fputs(line,fp);
      	for(i=0;i<iSize;i++)
      	{
        	for(j=0;j<jSize;j++)
              	{
                	sprintf(line," c%d-%d ",i+1,j+1);
                    	fputs(line,fp);
            	}
           	sprintf(line,"\n");
              	fputs(line,fp);
      	}
      	sprintf(line,")\n");
      	fputs(line,fp);
      	sprintf(line,"(:init\n(dir up)\n(dir down)\n(dir left)\n(dir right)\n");
      	fputs(line,fp);
      	sprintf(line,"(npc-facing up)\n(npc-emptyhands)\n(knife k)\n(gun g)\n");
      	fputs(line,fp);
      	for(i=0;i<iSize;i++)
      	{
        	for(j=0;j<jSize;j++)
            	{
                 	if(level[i][j]!='#')
                   	{
                      		if(i!=0)
                             	{
                              		if(level[i-1][j]!='#')
                                     	{
                                    		sprintf(line,"(adjacent c%d-%d c%d-%d up)\n",i+1,j+1,i,j+1);
                                                fputs(line,fp);
                                        }
                     	        }
                                if(i!=iSize-1)
                                {
                                	if(level[i+1][j]!='#')
                                     	{
                                         	sprintf(line,"(adjacent c%d-%d c%d-%d down)\n",i+1,j+1,i+2,j+1);
                                           	fputs(line,fp);
                                   	}
                            	}
                                if(j!=0)
                                {
                   	        	if(level[i][j-1]!='#')
                                     	{
                       		       		sprintf(line,"(adjacent c%d-%d c%d-%d left)\n",i+1,j+1,i+1,j);
                                              	fputs(line,fp);
                                        }
                             	}
                           	if(j!=jSize-1)
                               	{
                                	if(level[i][j+1]!='#')
                                    	{
                                        	sprintf(line,"(adjacent c%d-%d c%d-%d right)\n",i+1,j+1,i+1,j+2);
                                             	fputs(line,fp);
                                     	}
                               	}
          		}
                        if(level[i][j]=='n')
                       	{
                        	sprintf(line,"(npc-at c%d-%d)\n",i+1,j+1);
                                fputs(line,fp);
                    	}
                        else if(level[i][j]=='g')
                    	{
                      		sprintf(line,"(object-at g c%d-%d)\n",i+1,j+1);
                            	fputs(line,fp);
                   	}
                    	else if(level[i][j]=='k')
                     	{
                      		sprintf(line,"(object-at k c%d-%d)\n",i+1,j+1);
                            	fputs(line,fp);
                     	}
                      	else if(level[i][j]=='p')
                     	{
                       		sprintf(line,"(player-at c%d-%d)\n",i+1,j+1);
                             	fputs(line,fp);
                    	}
  		}
 	}
      	sprintf(line,")\n(:goal (player-down)))\n");
      	fputs(line,fp);
      	fclose(fp);
	for(i=0;i<iSize;i++)
		free(level[i]);
	free(level);
}
